(* 
   Figures Bin Xue and Sanndeep Shukla, 
   "Optimization of Back Pressure and Throughput 
    for Latency Insensitive Systems," ICCD 2010 
*)

let node relay x = x

let node ip_1_1 x = x
let node ip_1_2 x = (x, x)
let node ip_2_1 ((x::'a), (y::'a)) = x
let node ip_2_2 ((x::'a), (y::'a)) = (x, x)
let node ip_3_1 ((x::'a), (y::'a), (z::'a)) = x


let node t0 (x) = ip_1_1 (x)
let node t1 (x) = ip_1_1 (x)
let node t2 (x,y,z) = ip_3_1 (x,y,z)
let node t3 (x) = ip_1_2 (x)
let node t4 (x,y) = ip_2_1 (x,y)
let node t5 (x) = ip_1_1 (x)
let node t6 (x,y) = ip_2_1 (x,y)
let node t7 (x,y) = ip_2_1 (x,y)
let node t8 (x) = ip_1_2 (x)
let node t9 (x) = ip_1_2 (x)
let node t10 (x) = ip_1_2 (x)
let node t11 (x) = ip_1_1 (x)
let node t12 (x) = ip_1_1 (x)
let node t13 (x) = ip_1_1 (x)
let node t14 (x) = ip_1_2 (x)
let node t15 (x) = ip_1_1 (x)
let node t16 (x) = ip_1_2 (x)
let node t17 (x) = ip_1_1 (x)
let node t18 (x) = ip_1_2 (x)
let node t19 (x) = ip_1_1 (x)
let node t20 (x) = ip_1_1 (x)
let node t21 (x,y) = ip_2_1 (x,y)
let node t22 (x) = ip_1_1 (x)
let node t23 (x,y) = ip_2_1 (x,y)
let node t24 (x) = ip_1_1 (x)


let node figure2 () = out_23 where
  rec out_0 = t0 (buffer in_0)
  and out_1 = t1 (buffer in_1)
  and out_2 = t2 (buffer in_2_1,
		  buffer in_2_2,
		  buffer in_2_3)
  and out_3_1, out_3_2 = t3 (buffer in_3)
  and out_4 = t4 (buffer in_4_1,
		  buffer in_4_2)
  and out_5 = t5 (buffer in_5)
  and out_6 = t6 (buffer in_6_1,
		  buffer in_6_2)
  and out_7 = t7 (buffer in_7_1,
		  buffer in_7_2)
  and out_8_1, out_8_2 = t8 (buffer in_8)
  and out_9_1, out_9_2 = t9 (buffer in_9)
  and out_10_1, out_10_2 = t10 (buffer in_10)
  and out_11 = t11 (buffer in_11)
  and out_12 = t12 (buffer in_12)
  and out_13 = t13 (buffer in_13)
  and out_14_1, out_14_2 = t14 (buffer in_14)
  and out_15 = t15 (buffer in_15)
  and out_16_1, out_16_2 = t16 (buffer in_16)
  and out_17 = t17 (buffer in_17)
  and out_18_1, out_18_2 = t18 (buffer in_18)
  and out_19 = t19 (buffer in_19)
  and out_20 = t20 (buffer in_20)
  and out_21 = t21 (buffer in_21_1,
		    buffer in_21_2)
  and out_22 = t22 (buffer in_22)
  and out_23 = t23 (buffer in_23_1,
		    buffer in_23_2)
  and out_24 = t24 (buffer in_24)

  and in_0 = delay out_9_1
  and in_1 = merge 1(0) 4012 (delay out_0)
  and in_2_1 = delay out_1
  and in_2_2 = merge 1(0) 4012 (delay out_12)
  and in_2_3 = merge 1(0) 4012 (delay out_16_1)
  and in_3 = merge 1(0) 4012 (delay out_2)
  and in_4_1 = merge 1(0) 4012 (delay out_3_1)
  and in_4_2 = delay out_24
  and in_5 = delay out_4
  and in_6_1 = merge 1(0) 4012 (delay out_5)
  and in_6_2 = delay out_14_1
  and in_7_1 = merge 1(0) 4012 (delay out_10_1)
  and in_7_2 = delay out_15
  and in_8 = delay out_7
  and in_9 = delay out_8_1
  and in_10 = delay out_6
  and in_11 = merge 1(0) 4012 (delay out_9_2)
  and in_12 = merge 1(0) 4012 (delay out_11)
  and in_13 = delay out_3_2
  and in_14 = merge 1(0) 4012 (delay out_13)
  and in_15 = merge 1(0) 4012 (delay out_14_2)
  and in_16 = merge 1(0) 4012 (delay out_19)
  and in_17 = delay out_16_2
  and in_18 = delay out_17
  and in_19 = merge 1(0) 4012 (delay out_18_1)
  and in_20 = delay out_10_2
  and in_21_1 = delay out_20
  and in_21_2 = delay out_23
  and in_22 = merge 1(0) 4012 (delay out_21)
  and in_23_1 = merge 1(0) 4012 (delay out_8_2)
  and in_23_2 = delay out_22
  and in_24 = delay out_18_2


let node v1 (in_21_1, in_23_1) = out_23 where
  rec out_21 = t21 (buffer in_21_1,
		    buffer in_21_2)
  and out_22 = t22 (buffer in_22)
  and out_23 = t23 (buffer in_23_1,
		    buffer in_23_2)

  and in_21_2 = delay out_23
  and in_22 = merge 1(0) 4012 (delay out_21)
  and in_23_2 = delay out_22

let node v2 in_20 = out_20 where
  rec out_20 = t20 (buffer in_20)

let node v3 (in_2_3, in_4_2) = (out_8_2, out_10_2) where
  rec out_0 = t0 (buffer in_0)
  and out_1 = t1 (buffer in_1)
  and out_2 = t2 (buffer in_2_1,
		  buffer in_2_2,
		  buffer in_2_3)
  and out_3_1, out_3_2 = t3 (buffer in_3)
  and out_4 = t4 (buffer in_4_1,
		  buffer in_4_2)
  and out_5 = t5 (buffer in_5)
  and out_6 = t6 (buffer in_6_1,
		  buffer in_6_2)
  and out_7 = t7 (buffer in_7_1,
		  buffer in_7_2)
  and out_8_1, out_8_2 = t8 (buffer in_8)
  and out_9_1, out_9_2 = t9 (buffer in_9)
  and out_10_1, out_10_2 = t10 (buffer in_10)
  and out_11 = t11 (buffer in_11)
  and out_12 = t12 (buffer in_12)
  and out_13 = t13 (buffer in_13)
  and out_14_1, out_14_2 = t14 (buffer in_14)
  and out_15 = t15 (buffer in_15)

  and in_0 = delay out_9_1
  and in_1 = merge 1(0) 4012 (delay out_0)
  and in_2_1 = delay out_1
  and in_2_2 = merge 1(0) 4012 (delay out_12)
  and in_3 = merge 1(0) 4012 (delay out_2)
  and in_4_1 = merge 1(0) 4012 (delay out_3_1)
  and in_5 = delay out_4
  and in_6_1 = merge 1(0) 4012 (delay out_5)
  and in_6_2 = delay out_14_1
  and in_7_1 = merge 1(0) 4012 (delay out_10_1)
  and in_7_2 = delay out_15
  and in_8 = delay out_7
  and in_9 = delay out_8_1
  and in_10 = delay out_6
  and in_11 = merge 1(0) 4012 (delay out_9_2)
  and in_12 = merge 1(0) 4012 (delay out_11)
  and in_13 = delay out_3_2
  and in_14 = merge 1(0) 4012 (delay out_13)
  and in_15 = merge 1(0) 4012 (delay out_14_2)

let node v4 in_24 = out_24 where
  rec out_24 = t24 (buffer in_24)

let node v5 () = (out_16_1, out_18_2) where
  rec out_16_1, out_16_2 = t16 (buffer in_16)
  and out_17 = t17 (buffer in_17)
  and out_18_1, out_18_2 = t18 (buffer in_18)
  and out_19 = t19 (buffer in_19)

  and in_16 = merge 1(0) 4012 (delay out_19)
  and in_17 = delay out_16_2
  and in_18 = delay out_17
  and in_19 = merge 1(0) 4012 (delay out_18_1)


let node figure_3a () = out_23 where
  rec out_23 = v1 (buffer in_21_1, 
		   buffer in_23_1)
  and out_20 = v2 (buffer in_20)
  and out_8_2, out_10_2 = v3 (buffer in_2_3, 
			      buffer in_4_2)
  and out_24 = v4 (buffer in_24)
  and out_16_1, out_18_2 = v5 ()

  and in_21_1 = delay out_20
  and in_23_1 = merge 1(0) 4012 (delay out_8_2)
  and in_20 = delay out_10_2
  and in_2_3 = merge 1(0) 4012 (delay out_16_1)
  and in_4_2 = delay out_24
  and in_24 = delay out_18_2
